libzypp: zyppng::sat::detail Namespace Reference

libzypp 17.38.6

zyppng::sat::detail Namespace Reference

CLASS NAME : detail::DIWrap. More...

## Classes
class | IBasicPoolComponent
| Shared base for IPoolComponent and IPreparedPoolComponent. More...
class | DIWrap
| Wrapper around sat `detail::CDataiterator`. More...
class | RepositoryIterator
struct | ByRepository
| Functor filtering Solvable by Repository. More...
class | SolvableIterator
| Iterate over valid Solvables in the pool. More...
struct | convert_to_solvable
struct | convert_to_solvable< T, std::void_t< satSolvable_t< T > > >

## Typedefs
using | CDataiterator = zypp::sat::detail::CDataiterator
using | CDatamatcher = zypp::sat::detail::CDatamatcher
using | CMap = zypp::sat::detail::CMap
using | CPool = zypp::sat::detail::CPool
using | CQueue = zypp::sat::detail::CQueue
using | CRepo = zypp::sat::detail::CRepo
using | CSolvable = zypp::sat::detail::CSolvable
using | CSolver = zypp::sat::detail::CSolver
using | CTransaction = zypp::sat::detail::CTransaction
using | IdType = zypp::sat::detail::IdType
using | SolvableIdType = zypp::sat::detail::SolvableIdType
using | RepoIdType = zypp::sat::detail::RepoIdType
using | size_type = SolvableIdType
template<typename T>
using | satSolvable_t = decltype(std::declval<T>().satSolvable())

## Functions
void | cap2str (std::string &outs_r, CPool *pool_r, IdType id_r, int parop_r)
| Shared logic to convert a sat ID into a human readable string.
const char * | cap2str (CPool *pool_r, IdType id_r, int parop_r=0)
| Shared logic to convert a sat ID into a human readable string.
const char * | capRel2Str (int op_r)
| Convert a relation operator to its string representation.
static void | logSat (CPool *, void *data, int type, const char *logString)
template<typename T>
Pool & | poolFromType (T &)
template<typename T>
const Pool & | poolFromType (const T &)
template<>
Pool & | poolFromType (Repository &r)
template<>
const Pool & | poolFromType (const Repository &r)
template<>
Pool & | poolFromType (Repository &)
template<>
const Pool & | poolFromType (const Repository &)
template<>
Pool & | poolFromType (Solvable &s)
template<>
const Pool & | poolFromType (const Solvable &s)
template<>
Pool & | poolFromType (Solvable &)
template<>
const Pool & | poolFromType (const Solvable &)
static const IdType | noId (0)
static const IdType | emptyId (1)
static const IdType | solvablePrereqMarker (15)
| Internal ids satlib includes in dependencies.
static const IdType | solvableFileMarker (16)
static const IdType | namespaceModalias (18)
static const IdType | namespaceLanguage (20)
static const IdType | namespaceFilesystem (21)
static const SolvableIdType | noSolvableId (0)
| Id to denote Solvable::noSolvable.
static const SolvableIdType | systemSolvableId (1)
| Id to denote the usually hidden Solvable::systemSolvable.
static const RepoIdType | noRepoId (0)
| Id to denote Repo::noRepository.
bool | isDepMarkerId (IdType id_r)
| Test for internal ids satlib includes in dependencies.

## Variables
template<typename T>
constexpr bool | has_satSolvable_v = std::is_detected_v<satSolvable_t, T>

## Detailed Description

CLASS NAME : detail::DIWrap.

## Typedef Documentation

## ◆ CDataiterator

using zyppng::sat::detail::CDataiterator = zypp::sat::detail::CDataiterator

Definition at line 33 of file poolconstants.h.

## ◆ CDatamatcher

using zyppng::sat::detail::CDatamatcher = zypp::sat::detail::CDatamatcher

Definition at line 34 of file poolconstants.h.

## ◆ CMap

using zyppng::sat::detail::CMap = zypp::sat::detail::CMap

Definition at line 35 of file poolconstants.h.

## ◆ CPool

using zyppng::sat::detail::CPool = zypp::sat::detail::CPool

Definition at line 36 of file poolconstants.h.

## ◆ CQueue

using zyppng::sat::detail::CQueue = zypp::sat::detail::CQueue

Definition at line 37 of file poolconstants.h.

## ◆ CRepo

using zyppng::sat::detail::CRepo = zypp::sat::detail::CRepo

Definition at line 38 of file poolconstants.h.

## ◆ CSolvable

using zyppng::sat::detail::CSolvable = zypp::sat::detail::CSolvable

Definition at line 39 of file poolconstants.h.

## ◆ CSolver

using zyppng::sat::detail::CSolver = zypp::sat::detail::CSolver

Definition at line 40 of file poolconstants.h.

## ◆ CTransaction

using zyppng::sat::detail::CTransaction = zypp::sat::detail::CTransaction

Definition at line 41 of file poolconstants.h.

## ◆ IdType

using zyppng::sat::detail::IdType = zypp::sat::detail::IdType

Definition at line 43 of file poolconstants.h.

## ◆ SolvableIdType

using zyppng::sat::detail::SolvableIdType = zypp::sat::detail::SolvableIdType

Definition at line 44 of file poolconstants.h.

## ◆ RepoIdType

using zyppng::sat::detail::RepoIdType = zypp::sat::detail::RepoIdType

Definition at line 45 of file poolconstants.h.

## ◆ size_type

using zyppng::sat::detail::size_type = SolvableIdType

Definition at line 59 of file poolconstants.h.

## ◆ satSolvable_t

template<typename T>

using zyppng::sat::detail::satSolvable_t = decltype(std::declval<T>().satSolvable())

Definition at line 454 of file solvable.h.

## Function Documentation

## ◆ cap2str() [1/2]

void zyppng::sat::detail::cap2str | ( | std::string & | outs_r,
|  | CPool * | pool_r,
|  | IdType | id_r,
|  | int | parop_r )

Shared logic to convert a sat ID into a human readable string.

Handles recursive rich dependencies and architecture/namespace tagging.

Parameters

  outs_r | The string to append the result to.
  pool_r | The pool to use for ID lookups.
  id_r | The ID to convert.
  parop_r | Parent operator for recursive calls (determines bracing).

Definition at line 56 of file cap2str.cc.

## ◆ cap2str() [2/2]

const char * zyppng::sat::detail::cap2str | ( | CPool * | pool_r,
|  | IdType | id_r,
|  | int | parop_r = 0 )

Shared logic to convert a sat ID into a human readable string.

Handles recursive rich dependencies and architecture/namespace tagging.

Returns
  Returns a char array in a private memory area, this can be overridden when cap2str is called again

Definition at line 107 of file cap2str.cc.

## ◆ capRel2Str()

const char * zyppng::sat::detail::capRel2Str | ( | int | op_r | ) |

Convert a relation operator to its string representation.

Parameters

  op_r | The operator ID (e.g., REL_GT, REL_AND).

Returns
  String representation like " > " or " and ".

Definition at line 119 of file cap2str.cc.

## ◆ logSat()

void zyppng::sat::detail::logSat | ( | CPool * | ,
|  | void * | data,
|  | int | type,
|  | const char * | logString )
| static

Definition at line 66 of file pool.cc.

## ◆ poolFromType() [1/10]

template<typename T>

Pool & zyppng::sat::detail::poolFromType | ( | T & |  | ) |

## ◆ poolFromType() [2/10]

template<typename T>

const Pool & zyppng::sat::detail::poolFromType | ( | const T & |  | ) |

## ◆ poolFromType() [3/10]

template<>

Pool & zyppng::sat::detail::poolFromType | ( | Repository & | r | ) |

Definition at line 36 of file repository.cc.

## ◆ poolFromType() [4/10]

template<>

const Pool & zyppng::sat::detail::poolFromType | ( | const Repository & | r | ) |

Definition at line 42 of file repository.cc.

## ◆ poolFromType() [5/10]

template<>

Pool & zyppng::sat::detail::poolFromType | ( | Repository & | r | ) |

Definition at line 36 of file repository.cc.

## ◆ poolFromType() [6/10]

template<>

const Pool & zyppng::sat::detail::poolFromType | ( | const Repository & | r | ) |

Definition at line 42 of file repository.cc.

## ◆ poolFromType() [7/10]

template<>

Pool & zyppng::sat::detail::poolFromType | ( | Solvable & | s | ) |

Definition at line 42 of file solvable.cc.

## ◆ poolFromType() [8/10]

template<>

const Pool & zyppng::sat::detail::poolFromType | ( | const Solvable & | s | ) |

Definition at line 51 of file solvable.cc.

## ◆ poolFromType() [9/10]

template<>

Pool & zyppng::sat::detail::poolFromType | ( | Solvable & | s | ) |

Definition at line 42 of file solvable.cc.

## ◆ poolFromType() [10/10]

template<>

const Pool & zyppng::sat::detail::poolFromType | ( | const Solvable & | s | ) |

Definition at line 51 of file solvable.cc.

## ◆ noId()

const IdType zypp::sat::detail::noId | ( | 0 |  | ) |
| static

## ◆ emptyId()

const IdType zypp::sat::detail::emptyId | ( | 1 |  | ) |
| static

## ◆ solvablePrereqMarker()

const IdType zypp::sat::detail::solvablePrereqMarker | ( | 15 |  | ) |
| static

Internal ids satlib includes in dependencies.

MPL check in PoolImpl.cc

## ◆ solvableFileMarker()

const IdType zypp::sat::detail::solvableFileMarker | ( | 16 |  | ) |
| static

## ◆ namespaceModalias()

const IdType zypp::sat::detail::namespaceModalias | ( | 18 |  | ) |
| static

## ◆ namespaceLanguage()

const IdType zypp::sat::detail::namespaceLanguage | ( | 20 |  | ) |
| static

## ◆ namespaceFilesystem()

const IdType zypp::sat::detail::namespaceFilesystem | ( | 21 |  | ) |
| static

## ◆ noSolvableId()

const SolvableIdType zypp::sat::detail::noSolvableId | ( | 0 |  | ) |
| static

Id to denote Solvable::noSolvable.

## ◆ systemSolvableId()

const SolvableIdType zypp::sat::detail::systemSolvableId | ( | 1 |  | ) |
| static

Id to denote the usually hidden Solvable::systemSolvable.

## ◆ noRepoId()

const RepoIdType zypp::sat::detail::noRepoId | ( | 0 |  | ) |
| static

Id to denote Repo::noRepository.

## ◆ isDepMarkerId()

bool zypp::sat::detail::isDepMarkerId | ( | IdType | id_r | ) |
| inline

Test for internal ids satlib includes in dependencies.

Definition at line 57 of file PoolDefines.h.

## Variable Documentation

## ◆ has_satSolvable_v

template<typename T>

bool zyppng::sat::detail::has_satSolvable_v = std::is_detected_v<satSolvable_t, T>
| constexpr

Definition at line 457 of file solvable.h.